
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
//class for 2D/3D point data type

class _PNT{

   float arctan(float l,float m)
   {
     float tht;

     if (l==0) tht=PI/2;
         else tht=(float) atan( fabs ( m/ l));
     if (l<0) {
       if (m>0) 
          tht=PI-tht;
         else tht=PI+tht;
              }
      else
        if (m<0)tht=2*PI-tht;
        return(tht);
    } // of arctan


   public:
   float x;
   float y;
   float z;// f(x,y) for a 2D function

      _PNT(float a=0,float b=0,float c=0){x=a;y=b;z=c;}
      float get_x(){return(x);}
      float get_y(){return(y);}
      float get_z(){return(z);}
      void set(float a,float b,float c=0){x=a;y=b;z=c;}
      void print2D(){cout<<"("<<x<<","<<y<<")";}
      void print3D(){cout<<"("<<x<<","<<y<<","<<z<<")";}

      _PNT cart_to_polar_2D(_PNT origin)
          {
           _PNT polar;
            float rad,angle;
            float xl,yl;

          xl=x-origin.x;
          yl=y-origin.y;
          polar.x= (float)sqrt( (double)(xl*xl+yl*yl));
          polar.y=arctan(xl,yl);
           return(polar);
           }

        _PNT unit_vect()
         {
          _PNT uv;
           float mag;
           
           mag=sqr(x)+sqr(y);
           if(mag>0){
             mag=(float)sqrt((double)mag);
             uv.x=x/mag;
             uv.y=y/mag;
             uv.z=z/mag;
             }
           return(uv);
          }

        int IsZero()
        {
            if((x==0)&&(y==0)&&(z==0))return(1);
            else return(0);
         }


       _PNT operator+(_PNT ob)
        {
         _PNT temp;

          temp.x=x+ob.x;
          temp.y=y+ob.y;
          temp.z=z+ob.z;
          return(temp);
         }

       _PNT operator-(_PNT ob)
        {
         _PNT temp;

          temp.x=x-ob.x;
          temp.y=y-ob.y;
          temp.z=z-ob.z;
          return(temp);
         }



       float  operator*(_PNT ob)//dot product of two componets
        {
         float temp;

          temp=x*ob.x+y*ob.y+z*ob.z;
          return(temp);
         }

	 //  double   _PNT::distance(_PNT ob)
	   double   distance(_PNT ob) // Modified on 19/6/09
	   {
		   double mag;
           
           mag=sqr(x-ob.x)+sqr(y-ob.y)+sqr(z-ob.z);
           if(mag>0){
             mag=(double)sqrt((double)mag);
			 return mag;
			 }
		   else
			   return 0;
	   }



      };
