/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2001). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
#include <iostream>
#include <fstream>
#include <backward/strstream>
using namespace std;
#include <math.h>
#include <ctype.h>
#include <stddef.h>
#include <stdlib.h>
#include <strings.h>

#include <sys/types.h>    /* only include <sys/types.h> once */

#include "../classes_linux9/allqcif.h"
#include "../fractal_codec_classes/qdfstdecode.h"
#include "../fractal_codec_classes/relfrcode.h"
#include "../fractal_codec_classes/colvidfrcode.h"

int HRNG_SIZE,RNG_SIZE,L_GAP=3,GOP;
int startFrame, endFrame;
float ERR_LB,ERR_TH;

main(int argc,char **argv)
{
  _COLOR cim;
   _GREY imY, im1Y,im2Y;
   _GREY imU, im1U,im2U;
   _GREY imV, im1V,im2V;
  _COLVIDFRCODE vfrc;
  _QCIFVIDEO   vid;
  char *fname,*fcodename;
  int width,height;
  int i,FrameNo;
  double errY,errU,errV;
  int aNbitQ,bNbitQ;
  int aNbitR,bNbitR;
  float dataSize;

 fname= new char[100];
  fcodename=new char[100];
 if(argc==3){
  fcodename=argv[1];
  fname=argv[2];
  }
 else{
 cout<<"This is a test programme \n";
 cout<<"Name of codefile & destination file for qcif video sequence?\n";
 cin>>fcodename>>fname;
 }

   cout<<"Reading the compressed file... \n"<<flush;
   vfrc.readCode(fcodename);

   cout<<"Going to decompress .. into file"<<fname<<"\n"<<flush;
    vfrc.decompressIntoFile(fname);
 
       cout<<"Number of frames for data rate \n";
       cin>>i;
       dataSize=vfrc.computeDataSize(i);
       cout<<"Data Size "<<dataSize/1000.0<<"KB for "<<i<<" Frames \n";
 }
