
/*************************************************************************
 These codes are developed by Jayanta Mukherjee, Dept. of CSE, IIT Kharagpur
 (between 1997-2000). The codes may be reused for any research and academic
 purpose. An acknowledgement of their uses would be appreciated.
 *************************************************************************/
/* File : TIMER.h */
#include <unistd.h>
#include  <sys/types.h>
#include  <sys/times.h>
#include  <sys/param.h>

struct tms tms_before, tms_after;
long clock_tick_per_sec;

void Initial_Timer()
{
        clock_tick_per_sec=sysconf(_SC_CLK_TCK);
        times(&tms_before);
}

void Final_Timer()
{
        times(&tms_after);
}

/*
void Display_Timer()
{
         printf("stime:%d,utime:%d\n", (tms_after.tms_stime-tms_before.tms_stime), (tms_after.tms_utime-tms_before.tms_utime));
}
*/

double Get_stime()
    {
         return((double)(tms_after.tms_stime-tms_before.tms_stime)/(double)clock_tick_per_sec);
    }

double Get_utime()
    {
         return((double)tms_after.tms_utime-tms_before.tms_utime)/(double)clock_tick_per_sec;
    }


